<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2005 Bastien HUBERT (bastienhubert@hotmail.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'af imageoftheday' for the 'af_imageoftheday' extension.
 *
 * @author	Bastien HUBERT <bastienhubert@hotmail.com>
 */


require_once(PATH_tslib."class.tslib_pibase.php");
require ("conf.php");
class tx_afimageoftheday_pi1 extends tslib_pibase {
	var $prefixId = "tx_afimageoftheday_pi1";		// Same as class name
	var $scriptRelPath = "pi1/class.tx_afimageoftheday_pi1.php";	// Path to this script relative to the extension dir.
	var $extKey = "af_imageoftheday";	// The extension key.





	/*** Main function ***/
	
	function main($content,$conf)	{

		$this->conf=$conf;		// Setting the TypoScript passed to this function in $this->conf
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();		// Loading the LOCAL_LANG values
		$this->pi_USER_INT_obj=1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!

		
		
			$filter=$this->cObj->data["select_key"];
			switch($filter)	{
				case "FORM": 	
					$content = $this->form_main($content,$conf);
				break;
				case "UPLOAD": 	
					$content = $this->up_main($content,$conf);
				break;
				default:		
					$content = $this->print_main($content,$conf);
				break; 
			}		
	    
		return $this->pi_wrapInBaseClass($content);
		
	
	}
	//Fonction d'envoie de l'image
	
	function up_main($content,$conf){
		global $BACK_PATH,$PAGE_FORM,$PAGE_UP;
		
		$titre=$_POST[$this->prefixId]["DATA"]["title"];
		$description=$_POST[$this->prefixId]["DATA"]["description"];
		$auteur=$_POST[$this->prefixId]["DATA"]["auteur"];
		$email=$_POST[$this->prefixId]["DATA"]["email"];
		$datedujour=date( "d/m/y");
		
		
		//Vrification du type du fichier et de sa taille
		$ftmpname = $_FILES["file"]["tmp_name"];
		if ( $titre!="" && $auteur!="" && $description!="" && $email!="" &&
		($_FILES["file"]["type"]=="image/jpeg" || $_FILES["file"]["type"]=="image/gif") 
		&& $_FILES["file"]["size"]<500000 && $_FILES["file"]["error"]==0){
			
			$nomfichier=$_FILES["file"]["name"];
			
			//Remplacement des espaces par des '_'
			$decoupe = explode (" ",$nomfichier);
			$nbmorceau = count($decoupe);
			$compteur=1;

			$lien="";
			if (isset($decoupe[1])){
				foreach ($decoupe as $value){
					$lien.=$value;
					if ($compteur < $nbmorceau){$lien.="_";$compteur++;}
				}
				$nomfichier=$lien;
			}
			
			
			//Vrification qu'un fichier ne porte pas dja ce nom, auquel cas on ajoute [1] ou [2] etc au nom
						
			$motcoupe=explode(".",$nomfichier);
			
			$compteur=0;
			$d=dir("fileadmin/iod/");
			
			while (false !== ($entry = $d->read())) {
			  
			   if ($nomfichier==$entry){
			   		$compteur++;
					$nomfichier=$motcoupe[0]."[".$compteur."].".$motcoupe[1];
					$d->close();
					$d=dir("fileadmin/iod/");
				}
			}
			$d->close();
			
			$this->fileDestination='fileadmin/iod/'.$nomfichier;
			
			move_uploaded_file($ftmpname,$this->fileDestination);

			
			$query="insert into tx_afimageoftheday_images(title,description,linktoimage, utilise,date, auteur,email) Values ('$titre','$description','$this->fileDestination',4,'$datedujour','$auteur','$email')";
			if (!$result = mysql_query($query)){die (mysql_error());}
			
			$content='<H1>Image soumise avec succs</h1>
					 <p>Transfert effectu avec succs, votre image va maintenant tre valide par nos administrateurs avant d\'tre visible sur le site.</p>
					 <p>Merci pour votre participation et  bientt !</p>';
			return $content;
				
		}
		else { 
		//affichage du message d'erreur personnalis
		$content = "<H1>Erreur(s) dans le formulaire:</H1><br>";
		if ($titre=="" || $auteur=="" || $description=="" || $email=="" ){
			$content.="Au moins un des champs n'est pas rempli<br>";
		}
		if ($_FILES["file"]["type"]!="image/jpeg" && $_FILES["file"]["type"]!="image/gif"){
			$content.="Format de fichier inconnu, veuillez envoyer des fichiers Jpeg ou Gif<br>";
		}
		if($_FILES["file"]["size"]>500000){
			$content.="Fichier trop gros, il doit peser moins de 500 Ko<br>";
		}
		
		if($_FILES["file"]["error"]!=0){
			$content.="Erreur pendant le transfert, veuillez renvoyer le fichier";
		}
		return $content;
		
		}
		
		
	}
	
	//Fonction de formulaire d envoie dimage
	
	function form_main($content,$conf){
	global $BACK_PATH,$PAGE_FORM,$PAGE_UP;
		$content='
		<h1>Envoi de fichier</h1>
		<p><table>
			<tr>
				<td>
					Titre:
				</td>
				<td>
					<form action="'.$PAGE_UP.'" method="post" enctype="multipart/form-data">
					<input type="text" name="'.$this->prefixId.'[DATA][title]" size="35">
				</td>
			</tr>
			<tr>
				<td>
					Description:
				</td>
				<td>
					<textarea name="'.$this->prefixId.'[DATA][description]" cols="32"></textarea>
				</td>
			</tr>
			<tr>
				<td>
					Votre pseudo:
				</td>
				<td>
					<input type="text" name="'.$this->prefixId.'[DATA][auteur]" size="35">
				</td>
			</tr>
			<tr>
				<td>
					Votre email:
				</td>
				<td>
					<input type="text" name="'.$this->prefixId.'[DATA][email]" size="35">
				</td>
			</tr>
			<tr>
				<td>
					Image:
				</td>
				<td>

					<input type="file" name="file" size="35">
				</td>
			</tr>
			<tr>
				<td colspan="2" align="center">
				
					<input name="'.$this->prefixId.'[submit_button]" type="submit" value="envoyer">
				</td>
			</tr>
		</table></p>
		';
		return $content;
	}
	
	/**
	 * Fonction d'affichage
	 */
	function print_main($content,$conf)	{
		
		global $BACK_PATH,$PAGE_FORM,$PAGE_UP;
		$datedujour=date( "d/m/y");
		//Vrification qu'il n'y ait pas deja une image active (utilise==2)
		$query='select count(uid) from tx_afimageoftheday_images WHERE utilise=2 ';
			if (!$result = mysql_query($query)){die (mysql_error());}
			$row = mysql_fetch_array($result);
			if ($row[0]==0){
				$query = " select count(uid) from tx_afimageoftheday_images WHERE utilise=0";
				if (!$result = mysql_query($query)){die (mysql_error());}
				$row = mysql_fetch_array($result);
				
				if ($row[0]!=0){
						$query='select * from tx_afimageoftheday_images WHERE utilise=0';
						if (!$result = mysql_query($query)){die (mysql_error());}
						$row = mysql_fetch_array($result);
						
						$query="UPDATE tx_afimageoftheday_images SET utilise = 2, date='$datedujour' WHERE uid = '$row[uid]'";
						if (!$result = mysql_query($query)){die (mysql_error());}
						
						$urlimage=$row[linktoimage];
						miniature($urlimage);
					}
				else{
						$query='select * from tx_afimageoftheday_images WHERE utilise=1';
						if (!$result = mysql_query($query)){die (mysql_error());}
						$row = mysql_fetch_array($result);
						
						$query="UPDATE tx_afimageoftheday_images SET utilise = 2, date='$datedujour' WHERE uid = '$row[uid]'";
						if (!$result = mysql_query($query)){die (mysql_error());}
						
						$urlimage=$row[linktoimage];
						miniature($urlimage);
					}
				
			}
		//vrification de la date d'affichage de l'image actuelle
		$query='select * from tx_afimageoftheday_images WHERE utilise=2 ';
		if ($res = mysql_query( $query)){
			$row = mysql_fetch_array($res);
			$dateimage=$row[date];
			$olduid=$row[uid];
			

				
				
						
			
					if ($dateimage != $datedujour){
						//echo "date diffrentes";						
							
						$query="UPDATE tx_afimageoftheday_images SET utilise = 1 WHERE uid = '$row[uid]'";
						if (!$res = mysql_query( $query)){die(mysql_error());}							
						
						//Vrification qu'une playlist soit dfinie
						
						$query='select * from tx_afimageoftheday_images WHERE playlist=1';
						if (!$res = mysql_query( $query)){die(mysql_error());}
						$row = mysql_fetch_array($res);
						
						if ($row[uid]!=""){
							//echo '<font color="red">'.t3lib_div::debug($row).'</font>';
							$result = mysql_query("UPDATE tx_afimageoftheday_images SET utilise = 2, date='$datedujour', playlist=0 where playlist=1");
							$result = mysql_query('Update tx_afimageoftheday_images SET playlist=1 where playlist=2');
							//exec_UPDATEquery("tx_afimageoftheday_images","playlist=2","playlist=1");
							$result = mysql_query('Update tx_afimageoftheday_images SET playlist=2 where playlist=3');
							$result = mysql_query('Update tx_afimageoftheday_images SET playlist=3 where playlist=4');
							$result = mysql_query('Update tx_afimageoftheday_images SET playlist=4 where playlist=5');
							$result = mysql_query('Update tx_afimageoftheday_images SET playlist=5 where playlist=6');
							$result = mysql_query('Update tx_afimageoftheday_images SET playlist=6 where playlist=7');
							$urlimage=$row[linktoimage];
							miniature($urlimage);
							
						}
						else{						
						
							//Si rien de dfinit dans la play List
							
							$query='select count(uid) from tx_afimageoftheday_images WHERE utilise=0 ';
							if (!$res = mysql_query( $query)){die(mysql_error());}
							$row = mysql_fetch_array($res);
							
								if ($row[0]!=0){
									$rand=rand(1,$row[0]);
									
									/*$this->piVars['DATA']['utilise']=0;
									$this->piVars['DATA']['count']=$row[0];
									t3lib_div::debug($this->piVars);*/
									
									$query='select * from tx_afimageoftheday_images where utilise=0';
									if (!$res = mysql_query( $query)){die(mysql_error());}
									
										for ($i = 0; $i<$rand;$i++){
										$row = mysql_fetch_array($res);
										}
									
									$query="UPDATE tx_afimageoftheday_images SET utilise = 2, date='$datedujour' WHERE uid = '$row[uid]'";
									if (!$res = mysql_query( $query) ){die (mysql_error());}
									
									
									/*$this->piVars['DATA']['rand']=$rand;
									 $content='<br><img src="'.$urlimage.'">';*/
									 $urlimage=$row[linktoimage];
									 miniature($urlimage);
								}
								else{
								
									$query='select count(uid) from tx_afimageoftheday_images WHERE utilise=1 and uid!='.$olduid.'';
									if (!$res = mysql_query( $query)){die( mysql_error());}
									$row = mysql_fetch_array($res);
									/*$this->piVars['DATA']['utilise']=1;
									$this->piVars['DATA']['count']=$row[0];
									t3lib_div::debug($this->piVars);*/
									$rand=rand(1,$row[0]);
				
									$query='select * from tx_afimageoftheday_images where utilise=1 and uid!='.$olduid.'';
									if (!$res = mysql_query( $query)){die( mysql_error());}
									
										for ($i = 0; $i<$rand;$i++){
										$row = mysql_fetch_array($res);
										}
										
									$query="UPDATE tx_afimageoftheday_images SET utilise = 2, date='$datedujour' WHERE uid = '$row[uid]'";
									if ( !$res = mysql_query( $query) ){die (mysql_error());}
									$urlimage=$row[linktoimage];
									$this->piVars['DATA']['rand']=$rand;
									 miniature($urlimage);
								
							
								}
							}
					}

		}
		else{
               die( mysql_error() ); }
		
		
					$query='select linktoimage,title, auteur from tx_afimageoftheday_images WHERE utilise=2 ';
					if (!$res = mysql_query( $query)){die(mysql_error());}
					$row = mysql_fetch_array($res);
	  				$content=$content.'						
						<h1>Image du jour</h1>
						<a href="'.$row[linktoimage].'" onclick="window.open(this.href) ; return false"><img src="fileadmin/iod/iod.jpg" alt="'.$row[title].'" title="'.$row[title].' par '. $row[auteur].'" /></a>
						<h1><a href="'.$PAGE_FORM.'">Soumettre</a></h1>
						';
	
			return $content;
	}

}

function miniature($image){
    
		/* CONFIG */
		$chmDest="/temp/"; //destination pour la miniature
		$largeur_vignette=130;
		$hauteur_vignette=130;
		
		/*********/
		
		
		// resupere le nom de fichier
		$nameFile=basename($image);
			
	   
			// taille de la grande image
			$size=getimagesize($image);
			
			// Calcule les ratios mignature/image
			$ratioL=(ceil(($largeur_vignette*100)/$size[0]));
			$ratioH=(ceil(($hauteur_vignette*100)/$size[1]));
	
			// si le ratio larguer est plus grand que le ratio hauteur
			if ($ratioL>$ratioH){
				$size[2]=(ceil(($largeur_vignette*100)/$ratioL));
				$size[3]=(ceil(($hauteur_vignette*100)/$ratioL));
				$coordonneX="0";
				$coordonneY=(ceil(($size[1]-$size[3])/2));
			}
			else{
				$size[2]=(ceil(($largeur_vignette*100)/$ratioH));
				$size[3]=(ceil(($hauteur_vignette*100)/$ratioH));
				$coordonneX=(ceil(($size[0]-$size[2])/2));
				$coordonneY="0";
	
			}
			// recupere l'extention du fichier
			$extention_fichier=strtolower(substr(strrchr($image,'.'),1));
			
			if ($extention_fichier=="jpg"){
				// cr l'img de destination par rapport a la source
		   
				$srcImg = imagecreatefromjpeg($patch.$image);
			}
			else{
				// cr l'img de destination par rapport a la source
				$srcImg = imagecreatefromgif($patch.$image);    
			}
			
			$dstImg = imagecreatetruecolor($largeur_vignette,$hauteur_vignette); 
			imagecopyresampled($dstImg, $srcImg, 0, 0, $coordonneX, $coordonneY, $largeur_vignette, $hauteur_vignette, $size[2], $size[3]);
			// retourne et cre le fichier image

			
			
			imagejpeg ($dstImg, "fileadmin/iod/iod.jpg", 100);       
	 
			// libere la ram
			imagedestroy($srcImg);
			imagedestroy($dstImg);
	
	
	
		}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/af_imageoftheday/pi1/class.tx_afimageoftheday_pi1.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/af_imageoftheday/pi1/class.tx_afimageoftheday_pi1.php"]);
}

?>